/* tool/framebuffer.js
created lun. nov.  5 19:55:55 CET 2012 by whygee@f-cpu.org

add a bitmap memory zone to a map
*/

init_obj.push(fb={
  serial:0,
  redrawList:[],

  putPixel:function(w,a,v){ // window, address (even), value
    var f=w.fb.data;

    switch(w.bpp){
      case 8:
        // one pixel=1 byte, but 2 pixels packed in one half word
        a*=4;
        f[a  ]=
        f[a+1]=
        f[a+2]=
           v & F2;
        f[a+3]=F2; // Alpha = full on

        f[a+4]=
        f[a+5]=
        f[a+6]=
          (v>>8) &F2;
        f[a+7]=F2;
        break;

      case 16:
        // granularity : one pixel=2 bytes
        a*=2; // But one canvas pixel = 4 bytes
        f[a  ]=(v&31)<<3;
        f[a+1]=(v>>3)&252; // 63*4
        f[a+2]=(v>>8)&248; //31*8
        f[a+3]=F2; // Alpha = full on
        break;

      case 32:
        // one pixel = 4 bytes
        if(a & 2) // select which half word to write
          f[a  ]= v     &F2;
        else{
          f[a  ]= v     &F2;
          f[a+1]=(v>> 8)&F2;
          f[a+3]=F2; // Alpha = full on !!!!!!!!!!! 
        }
        break;
    }

    if (!w.dpy){
      w.dpy=true;
      fb.redrawList.push(w);
      redraw(fb.displayCallback);
    }
  },

  clear:function(e,w){
    w=w||parentWin(this);

    // flush the display
    var i=0,
      j=w.Ypx * w.Xpx * 4,
      f=w.fb.data;
    while(i<j)
      f[i++]=F2;

    // flush the memory
    j=w.bytes;
    i=0;
    f=w.memory.mem;
    while(i<j){
      f[i]=F4;
      i+=2;
    }

    w.ctx.putImageData(w.fb, 0, 0);
  },

  mire:function(e,w){
    w=w||parentWin(this);
    var i=0, j=w.Ypx * w.Xpx;

    switch(w.bpp){
      case 8:
        for (;i<j; i+=2)
          fb.putPixel(w,i,(((i+1)&F2)<<8)+(i&F2));
        break;

      case 16:
        for (;i<j; i++)
          fb.putPixel(w,i*2,i);
        break;

      case 32:
        for (;i<j; i++) {
          fb.putPixel(w, i*4   ,i);
          fb.putPixel(w,(i*4)+2,i>>16);
        }
        break;
    }
  },

/////////////////////////////////////////////////////////////

  changeBpp:function(w,b){ // b= 1, 2 or 4
    w.bpp=
      (w.Bpp=b)*8;
    Map.NewMem(w, 6, // Read and Write, no eXecute
      fb.memCallback, 0,
       w.bytes= w.Ypx * w.Xpx * w.Bpp);
    // dirty lookup
    var i, s=w.selBpp;
    for (i in s.options)
     if(b == s.options[i].value) {
       s.selectedIndex=i;
       break;
    }

    fb.mire(0,w);
  },

  selectChangeBpp: function(){
    fb.changeBpp(parentWin(this),
       +this.options[this.selectedIndex].value);
  },

/////////////////////////////////////////////////////////////

  displayCallback: function(){
    var w,i;
    for (i in fb.redrawList){
      w=fb.redrawList[i];
      w.dpy=false;
      w.ctx.putImageData(w.fb, 0, 0);
    }
    fb.redrawList=[];
  },

/*  eraseCallback: function(w){  using YASMed for now
    for (var i in w.Maps)
      Map.delEdit(w, w.Maps[i]);
  },*/

  memCallback: function(w,a,v,rwx,thread){ // window, address, value, right, thread ID
    if(rwx==2)
      fb.putPixel(w,a,v);
  },

/////////////////////////////////////////////////////////////

  start: function() {
    var w, b, c,d,e,f, i, can,
      l=256,
      h=256,
      cont=dcE("DIV"),
      s=document.createElement("SELECT"),
    w = ygwm.new_window("fb#"+(fb.serial++), null, cont,
       300, 420, 300, 260, false, true, true, true, false, "doc_cygr");

//    w.dpy=false; // flag to force redisplay at the next yield => set by mire
    w.eraseCallback=YASMed.eraseCallback;
    w.Maps=[];
    w.MapDiv=[];

    Map.NewMem(w, 1, 6, // R, W (no execute)
      YASMed.memCallback);


    cont.innerHTML=WARN+"Work in progress...";
    d=dcE("DIV");
    d.appendChild(Map.createMapSel(w));

      (c=dcE("DIV")).innerHTML=l+"*"+h+"px<br>";
    d.appendChild(c);

    button(d,"clr",fb.clear,0,"1em");

    s.options[0]=new Option("8bpp",1);
    s.options[1]=new Option("16bpp",2);
    s.options[2]=new Option("24bpp",4);
    s.title="Color depth";
    s.onchange=fb.selectChangeBpp;
    d.appendChild(
        w.selBpp=s);

    cont.appendChild(d);

    can
      =w.canvas
      =dcE("canvas");
    if (can.getContext) {
      can.style.border="1px solid black";

      w.fb=(
         w.ctx=can.getContext('2d')
      ).createImageData(
        can.width
          =w.Xpx
          =l,
        can.height
          =w.Ypx
          =h);

      cont.appendChild(can);

      fb.changeBpp(w,2);
    }
    else
      cont.innerHTML
        =WARN+"HTML5 Canvas not supported\nUse a more capable browser";
    return w;
  },

  init_obj: function(){
    menu.subMenuItem(menu.list["Tools"],i8n.fb, "tool/fb");
  }
});