/* yasep/tool/yasim.js
 created ven. oct.  5 06:38:36 CEST 2012 by whygee@f-cpu.org
 lun. oct.  8 21:49:12 CEST 2012 : renamed from simul.js
 sam. oct. 13 06:14:28 CEST 2012 moved adjustHeight to its own files

todo : flags

*/

/*blackList("BPcycle_id");
blackList("BPaddr_id");
blackList("BPvalReg_id");
blackList("BPopc_id"); */

/*
function tagFocus(){
  ygwm.focus_window(null,this.win);
  return false;
}
*/

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////

init_obj.push(sim={

  simCount:1,

///////////// floating cursor :
  create_cursor: function(col,cont,omd,w){
    var c=dcE("DIV");
    c.win=w;
    c.className="tag";
    c.style.color=col;
    c.innerHTML=cont+"<font size=\"+2\"><b>\u27A1</b></font>";
    c.onmousedown=omd;
    return c;
  },


///////////// Finite State Machine :
  states:["INIT", "STEP", "RUN", "STOP", "HALT", "FAULT", "DISCONNECTED"],
  // The actual state is a number stored in win.state

  changeState: function(w,n) {
    w.shortmsg("&nbsp;"+I8N("St")+"&nbsp;<i>"
      +sim.states[w.state
         =n]+"</i>");
    w.arrowDiv.style.display=(n<6)?"block":"none";
  },

  resetState: function(w,s) { // s is a forced state (like 6 during init or disconnection)
    var i,j;

    sim.changeState(w,s||0);

    w.currentInstruction=null;
    sim.stop(w);  // Stop if button pressed.

    w.cycle_id.innerHTML
      =w.cycle
      =w.address
      =w.result
      =s?"u":0;

    for (i in w.regs){
      w.regs[i]=null;
      w.regs_id[i].innerHTML="u";
      w.regs_id[i].id=""; //bgcolor
      (w.regs_histo[i]=j=dcE("DIV")).nl=0;
    }

    w.trace_id.innerHTML=""; // ZZZZzzzzapppp!
    w.traceLen=0;
    w.logBuff="";

    sim.displayRegHistory(0,w);

    // Clear history

    sim.regWrite(w,0,0); // PC=0
    w.Carry
   =w.Zero
   =0;
    w.Carry_id.checked
   =w.Zero_id.checked
   =w.BPstop // No fault or breakpoint
   =false;

    sim.flushChanges(0,w);

    // read instruction memory and disassemble
    sim.instrLoad(w);
    sim.updateASM(w);
  },

  flushChanges: function(e,t) {
    var i, w=parentWin(t||this);
    for (i in w.regs)
      w.regs_changed[i].innerHTML="";  // flush the bullets
  },

  instrLoad: function(w){
    // flush the changes
    for (var i=0;i<32;i++)
      w.regMod[i]=" ";  //    sim.mkLine(w);

    if (w.Map) {

      w.currentAddress=w.regs[0];

      // read/fetch instruction memory
      w.instrLen=2;
      //get first half :
      var y,a= 0x002B; // limited to 16 bits at once   IB uses READ_DST3
      a|= (w.cycle & F2) << 8;

      if (a&1) {
        w.instrLen=4;
        a|=(w.cycle & 0xF00) << 16;
      }

      w.currentInstruction=a;
      w.opcode=
          (a&=252); // 63<<2
      if (!profiles[w.profileName].valid[a]){
        sim.changeState(w,5);  // FAULT
        w.BPstop=true;
      }
      w.flags=Y.opcode_table[a].flags;
    }
    else
      w.currentInstruction=null;
  },

  updateASM:function(w){
    var a=w.currentInstruction;
      w.Disas_hex.innerHTML=int2hex(a);
      w.Disas_msg.innerHTML="";

    if(a!==null){
      if (profiles[w.profileName].valid[a&252]){ // 63<<2
        // disassemble the word
        Y.DISASM(a,w.DISASM);
        w.Disas_out.innerHTML=w.DISASM.instruction;
        w.Disas_out.style.backgroundColor=""; //default
      }
      else{
        w.Disas_out.style.backgroundColor="orange";
        w.Disas_out.innerHTML=I8N("asmie");
      }
    }
    else{
      w.Disas_out.style.backgroundColor="#777";
      w.Disas_out.innerHTML="u";
      w.Disas_msg.innerHTML=I8N("fcsm");
    }
  },

  multiread:{
         " ":"\u204E",
    "\u204E":"\u2051",
    "\u2051":"\u2042"
  },
  readReg:function(w, n, sym){
    n&=15;
    var b=sim.regIndexDisplay[n];
    w.regMod[b]
       =  sym  // the forced symbol has priority
       || sim.multiread[ w.regMod[b] ] // "increment" with the table
       || "?";  // if unknown state
    return w.regs[n];
  },

  oneStep: function(w) {
    var dst=-1, // NOT 0
       a=w.currentInstruction;
    // read operands

     w.dst3
    =w.snd
    =w.si4
    =null;

    if (~Y.IGNORE_SND & w.flags)
      w.snd=sim.readReg(w, a>>8);  // Y.OFFSET_SND;

    if (~Y.IGNORE_SI4 & w.flags){
      if (a & 1){  // Y.FIELD_IMMREG  : Long form
        if (a & 2){ // Y.FIELD_EXTFORM : extended form
          if (a & Y.FIELD_EXTIMM4) { //  short immediate
            w.si4=(a>>12)&15; // short immediate
            if (w.si4 & 8)
                w.si4|=~7; // sign extension
          }
          else // short register
            w.snd=sim.readReg(w, a>>12); // Y.OFFSET_SI4
        }
        else // long immediate
          if (~Y.IGNORE_IMM16 & w.flags){
            w.si4=a>>16; // sign extension
            if ((Y.IMM20 & w.flags) && (w.bpBits > 16)){
              w.si4&=F4; // remove the sign bits
              w.si4|=(a<<8)&0xF0000;
              if (a & 0x80) // sign extension
                w.si4|=~0xFFFFF;
            }
          }
      }
      else { // Short form
        if (a & 2){ // Y.FIELD_EXTFORM
          w.si4=(a>>12)&15; // short immediate
          if (w.si4 & 8)
              w.si4|=~7; // sign extension
        }
        else // short register
          w.snd=sim.readReg(w, a>>12); // Y.OFFSET_SI4
      }
    }

    if (((a&3) == 3) // Long extended
     &&(Y.READ_DST3 & w.flags))
      w.dst3=sim.readReg(w, a>>24);  // Y.OFFSET_DST3

    // execute

//    w.result=null;

    w.result= ( +new Date() +w.result) & w.bpMask;


    // write operands (if condition true)
    // if (condition==true){
    if(~Y.NO_WRITEBACK & w.flags){ // What about ABORT_WRITE and NO_CONDITION ?
      if (a & 1){  // Y.FIELD_IMMREG
        if (a & 2) // Y.FIELD_EXTFORM
          dst=24;  // Y.OFFSET_EXTDST3
        else
          dst=12;  //Y.OFFSET_SI4;
      }
      else
        dst=8; // Y.OFFSET_SND;
      dst=(a >> dst)&15;
      sim.regWrite(w, dst ,w.result);
    }
    // Carry, zero

    // read/write data memory : in sim.regWrite

    // display trace
    sim.logLine(w);

    // check cycle breakpoints
    w.cycle_id.innerHTML
      =++w.cycle;

    // writeback PC (if not already modified)
    // check address breakpoints => incorporated in PC writeback
// if... == " "
    if (dst != 0)
      sim.regWrite(w,0,w.instrLen+w.currentAddress); // This write will not trigger the "change" flag because it is reset just after

    sim.instrLoad(w); // flush the modify flags
  },

  runNext:null,

  insertRun:function(w,s){
    sim.changeState(w,s);
    var a=sim.runNext;
    if (a){
      var p
        =w.runNext=a.runNext;
                   a.runNext=w;
         w.runPrev=p.runPrev;
                   p.runPrev=w;
    }
    else{ // init the circular list
      sim.runNext
       =w.runNext
       =w.runPrev
       =w;
      redraw(sim.multiRun);
    }
  },

  stop:function(w){
    if (w.state<3) // INIT STEP or RUN (don't let DISCONNECTED, HALT or FAULT restart the whole thing)
      sim.changeState(w,3); // "STOP"

    var n=w.runNext;
    if(n){ // may be undefined
      if(w==n)
        sim.runNext=null;
      else {
        if(w==sim.runNext)
          sim.runNext=n;
        var a=w.runPrev;
        a.runNext=n;
        n.runPrev=a;
      }
      w.runNext=
      w.runPrev=null;
    }

    sim.updateASM(w);
  },

  buttonReset:function() {
    var w=parentWin(this);
    if(w.state<6) // don't force if it's disconnected
      sim.resetState(w);
  },

  buttonStop:function() {
    sim.stop(parentWin(this));
  },

  buttonStep: function() {
    var w=parentWin(this);
    if(w.state<4){  // don't let DISCONNECTED, HALT or FAULT restart the whole thing
      sim.stop(w);
      sim.oneStep(w);
      sim.updateASM(w);
    }
  },

  buttonMultiStep: function(e,t) {
    var w=parentWin(t||this);
    if (w.state<4) {
      sim.stop(w);
      w.skipCount=w.skipCycles;
      sim.insertRun(w,1); // "STEP"
    }
  },

  buttonRun: function(e,t) {
    var w=parentWin(t||this);
    sim.stop(w);
    if (w.state<4)
      sim.insertRun(w,2);// "RUN"
  },

  multiRun: function(){
    if (sim.runNext) {
      var d=+new Date()+500, // each lot of steps is 500ms
          w=sim.runNext;
      do {
        sim.oneStep(w);
        if (w.BPstop || (w.state==1 && (--w.skipCount <1)))
          return sim.stop(w);

        sim.runNext
          =w   // follow the linked list and do the backup in case it gets interrupted
          =w.runNext;
      } while(d> +new Date());

      // update the asm output,
      // scan the ring once
      w=sim.runNext;
      do {
        sim.updateASM(w);
        w=w.runNext;
      } while (w!=sim.runNext);

      redraw(sim.multiRun);
    }
  },

////////////////////////////////////////////

///////////// Profiles :
  change_profile: function(a,w) {
    if(typeof a!="string"){
      // when called from changing the selector
      var t=this;
      if(w)
        t=w.ProfileSel;
      else
        w=parentWin(t);
      a=t.options[t.selectedIndex].text;
    }
    else {
      var found=false;
      if (typeof profiles[a]!="object")
        return Al8N("Ipn");
      var i,sel=w.ProfileSel;
      for (i in sel.options) {
        if (sel.options[i].text==a) {
          found=true;
          break;
        }
      }
      if (!found) {
        // new profile added by the user since last click ?
        i=sel.options.length;
        sel.options[i]=new Option(a);        
      }
      sel.selectedIndex=i;
    }
    w.profileName=a;

    var m=0, b=profiles[a].datapath;
    if (w.bpBits != a) {
      w.DISASM.YASEP_TYPE
        =w.bpBits
        =b;
      while (b--)  // iterative mask creation because
        m+=m+1;    // 1<<32 == 1 !!! (5 LSB kept)
      w.bpMask=m;

      // check all the inputs under w.BPdiv, in case they are now out of range
      var l=w.BPdiv.getElementsByTagName("INPUT");
      for (b in l)
        if (l[b].id=="num")
            l[b].onkeyup();

//    update/redraw register values with new mask
      sim.redisReg(w);

//  this could change the cursor position in YASMed !
    }
  },

  update_proflist:function(u,t) {
    t=t||this;
    var p,s=t.selectedIndex,i=0;

    for (p in profiles) {
      // the position is reset to 0 each time the list is changed,
      // which makes some weird visual inconsistencies,
      // so update only if really needed (but does not really solve the "bug")
      // listBlur helps too.
      if (!t.options[i] || (t.options[i].text!=p))
        t.options[i]=new Option(p);
      i++;
    }
    t.selectedIndex=s>0?s:0; // by default s is -1 ?...
  },

  listBlur:function(){ // prevents a visual bug...
    var w=parentWin(this);
    sim.change_profile(w.profileName,w);
  },


/////////////// Radix
  chBase: function(t){
    var i, w=parentWin(t);
    w.num_func=sim["num_"+t.value];
    sim.redisReg(w);
  },

  num_bin: function(n,d){
    return toBin(n,d,1)+"b";
  },

  num_dec: function(n){
    return n;
  },

  num_hex: function(n){
    return int2hex(n);
  },

  redisReg: function(w){
    var r;
    for (i in w.regs){
      r=w.regs[i];
      w.regs_id[i].innerHTML=
         r!==null ? w.num_func(w.regs[i] & w.bpMask, w.bpBits) : "u";
    }
  },

/////////////// Register history

  displayRegHistory: function(n,w){
    if (!w){
      n=this.nr;
      w=parentWin(this);
    }
    w.regName.innerHTML=Y.registers_names[n];
    var f=w.HistoDiv;
    if(f.firstChild)
       f.removeChild(f.firstChild);
    f.appendChild(w.regs_histo[n]);
  },

  regIndexDisplay:[
    0, 2, 4, 6, 8, 10, // PC, R1-R5
    20,30,18,28,16,26,
    14,24,12,22 
  ],

////////////// Register write
  regWrite: function(w,r,v, sym) {
    r&=15; // check that r >= 0 and <16
    v&=w.bpMask; // check that value >= 0 and <= bitMask
    if (!r) {   // The LSB of the PC is always 0:
      if (v&1)
        sim.traceLog(w,WARN+I8N("awPL"));
      v&= ~1;
    }

    // if equal, don't log ?
    if(w.regs[r]!=v){

      // update the register value in w.regs
      w.regs[r]=v;
      var d,i,j,n
      // display the value
      =w.regs_id[r].innerHTML
          =w.num_func(v,w.bpBits);

      //toggle the "changed" flag
      w.regMod[sim.regIndexDisplay[r]+1]
        =w.regs_changed[r].innerHTML
        =sym||"\u25CF";

      // Change the background color if it's a A register that is parked
      if (r>6) {

         if(r&1){ // A register ?
/*       { // compute the parking address
          var p=r>>1, b="";
          if (v== p|(w.bpMask&~7))
            b="P";
          w.regs_id[r].id=b;
        } */
          w.regs_id[r].id= (v==((w.bpMask&~7)|(r>>1))) ?"P":"";

          // read memory
          sim.regWrite(w, r&14, w.cycle&w.bpMask,"\u25B2");
        }
        else{
          // write to memory
        }
      }
      // update the trace log

      // update the register log
      i=w.regs_histo[r];
      j=i.nl;
      if(w.traceMax){
        j++;
        (d=dcE("DIV")).innerHTML
           =pad_left(w.cycle,10)
           +pad_left(w.currentAddress,12)
           +"  "+pad_left(n,10);
        w.regs_histo[r].appendChild(d);
      }

      while(j>w.traceMax){
        i.removeChild(i.firstChild);
        j--;
      }
      i.nl=j;

      // scan the breakpoint list

    }
  },

  checkRegister:function(t){
    if(t.value=="u")
       t.value=0;
    var  n
      =sim.numval
      =str2int(t.value),
    w=sim.pw||(sim.pw=parentWin(edit_text.current_elem)),
    m=w.bpMask+1;
    edit_text.valid=!((n===null)||(n>=m)||(n<(m/-2)));
  },

  validRegister:function(t){ // normally, the sim.numval is correct because save is turned on when valid==true
    sim.regWrite(sim.pw, t.rn, sim.numval,"\u25C6");

    // erase source so innerHTML will be re-read next time after update by sim
    t.source
      =sim.pw
      =null;
  },
/*
////////////// Carry & Zero
///          e.onchange=sim["click"+name];
///          td.onclick=sim["display"+name];

  changeCarry:function(v) {
  },

  changeZero:function(v) {
  },

  clickCarry:function(v) {
  },

  clickZero:function(v) {
  },

  displayCarry: function(n,w){
  },

  displayZero: function(n,w){
  },
*/

/////////////// breakpoints (low level API)
/*
 // TODO : detect duplicate breakpoints

  addBr_cycle:function(w,cycle) {
  },

  addBr_addr:function(w,addr) {
  },

  addBr_valReg:function(w,val,reg) { // passe la valeur en négatif
  },

  toggleBr:function(w,br) { // passe la valeur en positif / négatif
  },

  deleteBr:function(w,br) {
  },

  changeBPval:function(w,br,val) {
  },

  changeBPreg:function(w,br,reg) {
  },
*/
/////////////// breakpoints display / interface

  addNewBP:function(d){
//    v.stopPropagation();
    var e,f;
    (e=dcE("DIV")).className="BPitem";
     e.id="off";

       f=dcE("DIV");
       f.className="minus";
       f.onclick=sim.deleteBP;
       f.title=I8N("dtb");
     e.appendChild(f);

       f=dcE("INPUT");
       f.type="checkbox";
       f.title=I8N("edtb");
       f.onchange=sim.click_toggleBr;
     e.active_id=f;
     e.appendChild(f);

    d.appendChild(e);

    //    d.style.display="block"; replaced by selective clicking:
    if(d.style.display!="block")
      d.previousSibling.spanShow.onclick();

    d.total_id.innerHTML= ++d.total;
    return e;
  },

  checkNumber: function(ev){
    var t=this,
      d=t.parentNode,
      w=parentWin(d),
      m=w.bpMask+1,
      n=str2int(t.value);
      a=d.active_id;
    // disables the breakpoint
    if(a.checked){
       a.checked=false;
       a.onchange();
     // note : it can be de-checked only if it was checked before,
     // meaning that t.parentNode.number was != null
     // so click_toggleBr executes the correct branch
     // (even when we just cleared the box)
    }
    if ((n===null)||(n>=m)||(n<(m/-2))) {
      n=null;
      t.style.backgroundColor="#F65";
    }
    else
      t.style.backgroundColor="";
    t.parentNode.number=n;
  },

  addNumberField:function(){
    var e=dcE("INPUT");
    e.id="num";
    edit_text.register(e, {
      size:10, maxsize:33,
      defaultValue: "0",
      func:sim.checkNumber
    });
    return e;
  },

  deleteBP:function(e,t){
    t=(t||this);
    var u=t.parentNode, // the breakpoint div
        d=u.parentNode; // container div
    d.total_id.innerHTML= --d.total;
    if (t.nextSibling.checked)
      d.active_id.innerHTML= --d.active;
    d.removeChild(u);
  },

  click_addBr_cycle:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPcycle_id,
        d=sim.addNewBP(i);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_addr:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPaddr_id,
        d=sim.addNewBP(i);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_valReg:function(e,t) { // passe la valeur en négatif
    var w=parentWin(t||this),
        i=w.BPvalReg_id,
        j,s,
        d=sim.addNewBP(i),
        r=I8N("comp").split(" ");

    d.appendChild(s=sim.regSel.cloneNode(true));
    s.selectedIndex=1;

    s=dcE("SELECT");
    for (j in r)
      sim.relSel.options[j]=new Option(r[j]);
    d.appendChild(s);
    s.selectedIndex=2;
    d.appendChild(sim.addNumberField());
  },

  click_addBr_opc:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPopc_id,
        j,k=0,
        v=[],
        s=dcE("SELECT"),
        d=sim.addNewBP(i);
    for(j in profiles[w.profileName].valid_instructions)
      v.push(j);
    v.sort();
    for(j in v)
      s.options[k++]=new Option(v[j]);
    d.appendChild(s);
  },

  click_toggleBr:function(e,t) { // passe la valeur en positif
    t=t||this;
    var p=t.parentNode,
        d=p.parentNode;
    if(p.number!==null){ // 
      d.active_id.innerHTML // houba !
        =(d.active+= t.checked?1:-1);
/*
      if (t.checked){
// activate the proper BP with the new value

      }
      else{
// disables
      }
*/
    }
    else // trying to click when invalid?
      t.checked=false; // force the checkbox back
  },
/*
  click_deleteBr:function(e,t) {
    t=t||this;
  },
*/

//////////////////////////////////////////////////////////////////////////////////////////
// trace

//  mkLine:function(w){   // Moved to instrLoad
//    for (var i=0;i<32;i++)
//      w.regMod[i]=" ";
//  },

  traceLog:function(w, msg){
    w.logBuff+="\n"+msg;
  },

  logLine:function(w){
    var i=w.traceLen+1,
     j=w.currentInstruction & 252,
     o=Y.opcode_table[j],
     f=dcE("DIV");
     f.innerHTML=pad_left(w.cycle,9)
         +pad_left(w.currentAddress,11) //" 4294967296"
         +pad_left(o?o.name:("("+j+")"),6)
         +" "+w.regMod.join("")+" c Z"
         +pad_left(w.result,12)
         +w.logBuff;
    w.logBuff="";
    w.trace_id.appendChild(f);
    w.trace_id.scrollTop=w.trace_id.scrollHeight;
    w.HistoDiv.scrollTop=w.HistoDiv.scrollHeight;
    // flush oldest traces
    while(i>w.traceMax){
      w.trace_id.removeChild(w.trace_id.firstChild);
      i--;
    }
    w.traceLen=i;
  },

// for changing the trace depth :
  checkTraceMax:function(t){
    var  n
      =sim.numval
      =str2int(t.value);
    edit_text.valid=((n!==null)&&(n>=0));
  },

  validTraceMax:function(t){ // normally, the sim.numval is correct because save is turned on when valid==true
    parentWin(edit_text.current_elem).traceMax = sim.numval;
    // erase source so innerHTML will be re-read next time after update by sim
    t.source=null;
    // flush excedent : the while() in logLine
  },

//////////////////////////////////////////////////////////////////////////////////////////
/*
// Read the memory

  readMem:function(w,addr){
  },

  writeMem:function(w, addr, val){
  },
*/
//////////////////////////////////////////////////////////////////////////////////////////

/* // call Map.delSim directly
  eraseCallback:function(w){
    Map.delSim(w); // calls stop
  },
*/

/////////////// Building a window
  start: function() {
    var cont=dcE("DIV"),
      w = ygwm.new_window(
         "YASim "+sim.simCount, null, cont,
         600, 700, 40, 70, false, true, true, true, false, "ms2_yelo"),
      c, d, f, i, p, tt,tb,tr,td, sel=dcE("SELECT");

//    w.bpMask=F4;  set at the end by a call to change_profile
//    w.bpBits=16;

    w.eraseCallback=Map.delSim; //sim.eraseCallback; // In case we close the window during a simulation run
    w.Map=null;

    w.regs=[];
    w.regs_histo=[];
    w.regs_id=[];
    w.regs_changed=[];
    w.regMod=[];

    Y.opcodeInterface(w);


/////// Top :

    (e=w.arrowDiv=dcE("DIV")).className="tagArea";
     e.title=I8N("DDax");
     e.appendChild(sim.create_cursor("red",sim.simCount,null));
    e.style.display="none"; // hidden when not disconnected
    cont.appendChild(e);

    w.state=sim.INIT;
      d=dcE("DIV");
      button(d,"\u21E4",sim.buttonReset,"Reset"); //x21E4 ⇤ reset
      button(d,"\u25B6",sim.buttonRun,"Run");         //x25B6 ▶  run
      button(d,"\u25FC",sim.buttonStop,"Stop");        //x25FC ◼ stop
// other : \u2933  ⤳  skip over function calls
      button(d,"\u21B7",sim.buttonStep,"Step");        //x21B7 ↷ step
      button(d,"\u21B7\u21B7\u21B7",sim.buttonMultiStep,"mStp");

      (e=dcE("SPAN")).innerHTML="&nbsp;"+I8N("stp");
      d.appendChild(e);
      d.appendChild(e=dcE("INPUT"));
      edit_text.register(e, {
        size:5, maxsize:5,
        defaultValue: "10",
        func: function(ev){
          var t=this;
          edit_text.filter_number(t);
          var n=str2int(t.value);
          if (n<2)
              n=2;
          parentWin(t).skipCycles
            =t.value
            =n;
        }});
    w.skipCycles=10;

      (e=dcE("SPAN")).innerHTML="&nbsp;"+I8N("Cycle")+"&nbsp;#";
      d.appendChild(e);
      d.appendChild(w.cycle_id=dcE("SPAN"));
    cont.appendChild(d);

/// Disassembler
      (e=dcE("DIV")).innerHTML=I8N("Instruction")+':&nbsp;<span id="hex">u</span>=<a style="cursor:pointer" class="asm_active" id="disas" onclick="wa(\'ASM/asm#a?\'+this.innerHTML)"> </a> &nbsp; <span id="msg"></span>';
      (w.Disas_div=e).style.margin="2px";
    d.appendChild(e);
     w.Disas_out=getById("disas","A",e);
     w.Disas_hex=getById("hex","SPAN",e);
     w.Disas_msg=getById("msg","SPAN",e);

    w.DISASM= new Y.DISASM_context(function(col,msg){ // closure, but can't avoid it simply
      if(col!="blue"){
        w.Disas_out.style.backgroundColor=col;
        w.Disas_msg.innerHTML=msg;
      }
    });


/////// Configuration

    (d=dcE("DIV")).appendChild(Map.createMapSel(w));

      (e=dcE("DIV")).innerHTML=I8N("TrD")+':<span id="traceMax"></span> &nbsp; '+I8N("prf")+":&nbsp;";
      // profile selector
      sel.onblur=sim.listBlur;
      e.appendChild(
        w.ProfileSel=sel);
    d.appendChild(e);
 
    (f=getById("traceMax","SPAN",e)).title=I8N("TrDt");
/*    f.innerHTML
      =w.traceMax
      =20;*/
    edit_text.register(f, {
      size:4, maxsize:4,
      defaultValue:
        f.innerHTML
         =w.traceMax
         =20,
      check: sim.checkTraceMax,
      func:  sim.validTraceMax
    });

/*
// source :
        (e=dcE("DIV")).innerHTML="Source : ☑JS <strike>GHDL</strike> <strike>YCD</strike>";
      d.appendChild(e);

 // JS: selecteur de YASMed
 // GHDL
 // YCD

// import/export config
*/

    h3(cont,d,"cnf");


/////// Registers

      (tt=dcE("TABLE")).style.fontFamily="monospace";
       tt.style.textAlign="right";
       tt.style.borderSpacing="0px";
       tt.appendChild(tb
         =dcE("TBODY"));
       c='<th onclick="sim.flushChanges(0,this)" title="'+I8N("fcm")
         +'"style="cursor:pointer">\u2260</th><th>Reg</th><th>'+I8N("val")+'</th><th>&nbsp;</th>';
       (tr=dcE("TR")).innerHTML=c+c;
       tb.appendChild(tr);

       for (i in Y.registers_names){
         w.regs[i]=null;
         c=Y.registers_names[i];
         if(!(+i & 1))
           tr=dcE("TR");

           (td=dcE("TD")).className=c[0];
         tr.appendChild(
              w.regs_changed[i]=td);

           (td=dcE("TD")).className=c[0];
           td.innerHTML=c+":";
           td.title=I8N("cvlv");
           td.style.cursor="pointer";
           td.nr=+i; //passes the argument through "this"
           td.onclick=sim.displayRegHistory;
           td.style.padding="1px";
         tr.appendChild(td);

           (td
             =w.regs_id[i]
             =dcE("TD")).className=c[0];
//           td.innerHTML="u"; // change_profile calls redisReg  will be removed soon thanks to initialisation
           edit_text.register(td, {
             size:10, maxsize:33,
             defaultValue: "0",
             check: sim.checkRegister,
             func:  sim.validRegister
           });
           td.rn=i; // used later so the proper register gets written
         tr.appendChild(td);

         tr.appendChild(dcE("TD"));

         if(+i & 1)
           tb.appendChild(tr);
       };

      function flag(name){
        tr.appendChild(dcE("TD"));
           (td=dcE("TD")).colSpan=2;
          td.innerHTML=name+":";
          (e=dcE("INPUT")).type="checkbox";
          e.onchange=sim["click"+name];
          td.onclick=sim["display"+name];
          td.style.cursor="pointer";
          td.appendChild(
             w[name+"_id"]=e);
        tr.appendChild(td);
        tr.appendChild(dcE("TD"));
      }

      tr=dcE("TR");
        flag("Carry");
        flag("Zero");
      tb.appendChild(tr);

      (e=dcE("DIV")).appendChild(tt);
       e.style.position="relative";
       e.style.cssFloat="left";
      (d=dcE("DIV")).appendChild(e);

      d.appendChild(e=dcE("FORM"));
        e.style.fontSize="70%";
        f='<input type="radio" name="rb" onclick="sim.chBase(this)" value=';
        e.innerHTML=I8N("rdx")
           +f+'"bin"/> bin&nbsp;'
           +f+'"dec"/> dec&nbsp;'
           +f+'"hex" checked="checked"/> hex';

      d.appendChild(e=dcE("DIV"));
       e.id="histoReg";
       e.innerHTML='<u>'+I8N("ho")+' <span id="regName"></span>:</u><br>   cycle     '
           +pad_left(I8N("adr"),8)+'    '+pad_left(I8N("val"),7)+'<div id="HistoDiv"></div>';
       w.regName=getById("regName","SPAN",e);
       adjustHeight(w.HistoDiv
          =getById("HistoDiv","DIV",e),100);

    h3(cont,d,"rgs");
    w.num_func=sim.num_hex;

/////// Breakpoints
      function newBP(text,fun,i){
        (f=dcE("DIV")).className="simBP";
        var g=dcE("DIV");
           g.onclick=fun;
           g.className="plus";
           g.title=I8N("Canb");
         f.appendChild(g);

          (g=dcE("SPAN")).innerHTML='<span>\u25BD</span>&nbsp;<i>(<span id="active"></span>/<span id="total"></span>)</i>&nbsp; '+I8N(text)+" :";
           g.onclick=showhideNext;
           g.title=I8N("ctsh");
           g.style.cursor="pointer";
           f.spanShow=g; ////!!!
         f.appendChild(g);

        d.appendChild(f);
        d.appendChild(g
           =w[i]
           =dcE("DIV")); // The sub-div
         g.style.display="block";
         (g.active_id=getById("active","SPAN",f)).innerHTML=g.active
        =(g.total_id =getById("total" ,"SPAN",f)).innerHTML=g.total
           =0;
      }

      (w.BPdiv
        =d
        =dcE("DIV")).style.display
                         ="block";
        newBP("sac",sim.click_addBr_cycle,   "BPcycle_id");                // blacklist(BPcycle_id)....
        newBP("saia",sim.click_addBr_addr,   "BPaddr_id");
        newBP("sorw",sim.click_addBr_valReg, "BPvalReg_id");
        newBP("sopc",sim.click_addBr_opc,    "BPopc_id");
    h3(cont,d,"brk",d);

////////////////// Trace

       (d=dcE("DIV")).style.fontFamily="monospace";
    // The fixed header
//       d.style.position="relative";
       d.style.whiteSpace="pre";
         f='<span style="background-color:#';
         i='</span>';
       d.innerHTML='<div style="position:absolute;top:-1.3em;right:1em;cursor:pointer;background-color:#DFD"'
+' title="'+I8N("shms")+'" onclick="toggle(this.nextSibling)">'+I8N("lgd")+'</div>'
+'<div style="display:none;border:2px solid #dedefa">'
+I8N("lgnd")+'</div>'
// The actual header :
+'<div>    cycle    address  opc  PC'
+f+'A0A0D0">R1R2R3R4R5'+i
+f+'D0A0A0">D1D2D3D4D5'+i
+f+'A0D0A0">A1A2A3A4A5'+i+' C Z   value</div>';

     // The scrolling contents
      d.appendChild(
         w.trace_id=dcE("DIV"));
    h3(cont,d,"trc", w.trace_id,150);

///////////////////////////////////////////////
// The end :
    cont.appendChild(dcE("HR"));

///////////////////////////////////////////////

    // done at the end so it updates the display
    (sel.onfocus=sim.update_proflist)(0,sel);
    (sel.onchange=sim.change_profile)(0,w); // calls sim.redisReg(w);
    sim.resetState(w,6);   // force "DISCONNECTED"
    w.simCount=sim.simCount++;

///////////////////////////// ugly dev stuff here /////////////////////////////

////////// créer un breakpoint par programme ici :


//////////// send test signals :

/*
     (d=dcE("BUTTON")).innerHTML="add trace";
     d.onclick=function(){
       sim.logLine(w);
     };
   h3(cont,d,"ctl");

  sel.disabled=true;// when using an external core
  sim.change_profile("microYASEP",w);
  sim.updateASM(w,0x84); // triggers an error
*/
    return w;
  },

  init_obj: function(){
//    var i;
//    for (i in sim.states)  unused
//      sim[sim.states[i]]=i;

    sim.regSel=dcE("SELECT");
    for (var i in Y.registers_names)
      sim.regSel.options[i]=new Option(Y.registers_names[i]);

    menu.subMenuItem(menu.list["Tools"],i8n.sim, "tool/YASim");
  }

});
